#ifndef _NULLPO_H_
#define _NULLPO_H_

#if __STDC_VERSION__ < 199901L
# if __GNUC__ >= 2
#  define __func__ __FUNCTION__
# else
#  define __func__ ""
# endif
#endif

#define NLP_MARK __FILE__, __LINE__, __func__

/*----------------------------------------------------------------------------
 * Macros
 *----------------------------------------------------------------------------
 */
/*======================================
 * Null`FbN y o͌ return
 *--------------------------------------
 * nullpo_ret(t)
 *   ߂l 0Œ
 * []
 *  t       `FbNΏ
 *--------------------------------------
 * nullpo_retr(ret, t)
 *   ߂lw
 * []
 *  ret     return(ret);
 *  t       `FbNΏ
 *--------------------------------------
 * nullpo_retv(t)
 *   ߂l Ȃ
 * []
 *  t       `FbNΏ
 *--------------------------------------
 * nullpo_ret_f(t, fmt, ...)
 *   ڍ׏o͗p
 *   ߂l 0
 * []
 *  t       `FbNΏ
 *  fmt ... vprintfɓn
 *    l֌Wϐ̏oȂǂ
 *--------------------------------------
 * nullpo_retr_f(ret, t, fmt, ...)
 *   ڍ׏o͗p
 *   ߂lw
 * []
 *  ret     return(ret);
 *  t       `FbNΏ
 *  fmt ... vprintfɓn
 *    l֌Wϐ̏oȂǂ
 *--------------------------------------
 */
 
#define nullpo_retr(ret, t) \
	if (nullpo_chk(NLP_MARK, (void *)(t))) {return(ret);}

#define nullpo_retv(t) \
	if (nullpo_chk(NLP_MARK, (void *)(t))) {return;}

#define nullpo_ret(t) \
	nullpo_retr(0, (t))


// ψ}NɊւRpC
#if __STDC_VERSION__ >= 199901L
/* C99ɑΉ */
#define nullpo_retr_f(ret, t, fmt, ...) \
	if (nullpo_chk_f(NLP_MARK, (void *)(t), (fmt), __VA_ARGS__)) {return(ret);}

#define nullpo_ret_f(t, fmt, ...) \
	nullpo_retr_f(0, (t), (fmt), __VA_ARGS__)

#elif __GNUC__ >= 2
/* ÂGCCp */
#define nullpo_retr_f(ret, t, fmt, args...) \
	if (nullpo_chk_f(NLP_MARK, (void *)(t), (fmt), ## args)) {return(ret);}

#define nullpo_ret_f(t, fmt, args...) \
	nullpo_retr_f(0, (t), (fmt), ## args)

#else

/* ̑̏ꍇEEE orz */

#endif

/*----------------------------------------------------------------------------
 * Functions
 *----------------------------------------------------------------------------
 */
/*======================================
 * nullpo_chk
 *   Null`FbN y o
 * []
 *  file    __FILE__
 *  line    __LINE__
 *  func    __func__ (֐)
 *    ɂ NLP_MARK gƂ悢
 *  target  `FbNΏ
 * [Ԃl]
 *  0 OK
 *  1 NULL
 *--------------------------------------
 */
int nullpo_chk(const char *file, int line, const char *func, const void *target);


/*======================================
 * nullpo_chk_f
 *   Null`FbN y ڍׂȏo
 * []
 *  file    __FILE__
 *  line    __LINE__
 *  func    __func__ (֐)
 *    ɂ NLP_MARK gƂ悢
 *  target  `FbNΏ
 *  fmt ... vprintfɓn
 *    l֌Wϐ̏oȂǂ
 * [Ԃl]
 *  0 OK
 *  1 NULL
 *--------------------------------------
 */
int nullpo_chk_f(const char *file, int line, const char *func, const void *target,
                 const char *fmt, ...)
                 __attribute__((format(printf,5,6)));


/*======================================
 * nullpo_info
 *   nullpoo
 * []
 *  file    __FILE__
 *  line    __LINE__
 *  func    __func__ (֐)
 *    ɂ NLP_MARK gƂ悢
 *--------------------------------------
 */
void nullpo_info(const char *file, int line, const char *func);


/*======================================
 * nullpo_info_f
 *   nullpoڍ׏o
 * []
 *  file    __FILE__
 *  line    __LINE__
 *  func    __func__ (֐)
 *    ɂ NLP_MARK gƂ悢
 *  fmt ... vprintfɓn
 *    l֌Wϐ̏oȂǂ
 *--------------------------------------
 */
void nullpo_info_f(const char *file, int line, const char *func, 
                   const char *fmt, ...)
                   __attribute__((format(printf,4,5)));


#endif
